.486
.model flat,stdcall
option casemap:none

   include trivia.inc

displayCategoryDialog PROTO hWnd:HWND
displayLicenseMsg proto hWnd:HWND
showGpl proto hWnd:HWND
gplProc proto hWnd:HWND,msg:UINT,wParam:WPARAM,lParam:LPARAM

   
.data
   ClassName db "programming_trivia",0
   align 4

statusParts dd 7 dup (0) 

gamesWon db "0 won",0
align 4

gamesLost db "0 lost",0
align 4 
   
   AppName  db "Programming Trivia",0
   align 4
   
.data?
   hInstance HINSTANCE ?
   CommandLine LPSTR ?
hStatus HWND ?


.code


; ---------------------------------------------------------------------------


start:
	
	call InitCommonControls
	
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,IDR_MENU
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
startMsgLoop:
		invoke GetMessage, ADDR msg,NULL,0,0
		
		test eax, eax
		jz endMsgLoop
		
				invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	jmp startMsgLoop
	endMsgLoop:
		
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov eax, uMsg
	
	cmp eax, WM_DESTROY
	jne notDestroy
						invoke PostQuitMessage,NULL
		jmp endMsgCompare
		
		notDestroy:
				
				cmp eax, WM_CREATE
				jne notCreate
				invoke CreateStatusWindow,WS_CHILD OR WS_VISIBLE OR SBARS_SIZEGRIP,\
				NULL, hWnd,IDC_STATUSBAR
				mov hStatus, eax
				
				invoke setStatusParts,hWnd
				
								invoke SendMessage,hStatus,SB_SETTEXT,1,addr gamesWon
				invoke SendMessage,hStatus,SB_SETTEXT,2,addr gamesLost
								
				invoke SetTimer,hWnd,IDC_TIMER,1000,NULL
				
								jmp endMsgCompare
				
				notCreate:
				
				cmp eax, WM_SIZE
				jne notSize
invoke resizeWindow,hWnd			
				
jmp endMsgCompare
				
				notSize:
				
				cmp eax, WM_TIMER
				jne notTimer
				invoke timerProc,wParam
				jmp endMsgCompare
				
				notTimer:
				
				cmp eax, WM_COMMAND
							jne notCommand
							mov eax, wParam
			
			; messages from the file menu
cmp ax, IDM_EXIT
jne notExit
invoke SendMessage, hWnd, WM_CLOSE, 0, 0
jmp endMsgCompare

notExit:

; messages from the edit menu
cmp ax, IDM_CATEGORIES
jne notCategories
invoke displayCategoryDialog,hWnd
jmp endMsgCompare

notCategories:

; Messages from the view menu
cmp ax, IDM_STATUS_BAR
jne notStatusBar
invoke setStatusBar,hWnd
jmp endMsgCompare

notStatusBar:

; messages from the Window menu
cmp ax, IDM_RESTORE
jne notRestore
	invoke ShowWindow,hWnd,SW_RESTORE
	jmp endMsgCompare
	
	notRestore:
	
cmp ax, IDM_MINIMIZE
jne notMinimize
		invoke ShowWindow,hWnd,SW_MINIMIZE
		jmp endMsgCompare
		
		notMinimize:
		
		cmp ax, IDM_MAXIMIZE
		jne notMaximize
					invoke ShowWindow,hWnd,SW_MAXIMIZE
					jmp endMsgCompare
			
			notMaximize:
			
		cmp ax, IDM_HIDE
		jne notHide
							invoke ShowWindow,hWnd,SW_HIDE
							jmp endMsgCompare
							
							notHide:
										
										cmp ax, IDM_CLOSE
										jne notClose
														invoke SendMessage,hWnd,WM_CLOSE,0,0
														jmp endMsgCompare
				
				notClose:
				
				; Messages from the help menu
cmp ax, IDM_LICENSE
jne notLicense
					invoke displayLicenseMsg,hWnd
					jmp endMsgCompare
		
		notLicense:
		
		cmp ax, IDM_GPL
		jne notGpl
		invoke showGpl,hWnd
		jmp endMsgCompare
		
		notGpl:
		
		jmp endMsgCompare
		
		notCommand:
		
					invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	
	endMsgCompare:
		
	xor eax,eax
	ret
WndProc endp


setStatusBar proc hWnd:HWND
	
LOCAL menuinfo:MENUITEMINFO
LOCAL hMenu:HMENU

	
	invoke GetMenu,hWnd
	mov hMenu, eax
	
	mov menuinfo.cbSize, SIZEOF MENUITEMINFO
	mov menuinfo.fMask, MIIM_STATE
	
	invoke GetMenuItemInfo,hMenu, IDM_STATUS_BAR, FALSE, addr menuinfo
	
	mov eax,menuinfo.fState
	
	cmp eax, MFS_CHECKED
	jne notChecked
invoke ShowWindow,hStatus,SW_HIDE
mov eax, MFS_UNCHECKED
jmp endCheck
			notChecked:
invoke ShowWindow,hStatus,SW_SHOW
mov eax, MFS_CHECKED	
	endCheck:
mov menuinfo.fState, eax
;### SEE - TODO1: ###
	invoke SetMenuItemInfo,hMenu, IDM_STATUS_BAR, FALSE, addr menuinfo
	
	
	ret

setStatusBar endp

resizeWindow proc hWnd:HWND
	
		invoke SendMessage,hStatus,WM_SIZE,0,0
	
	invoke setStatusParts,hWnd
	
			ret

resizeWindow endp


timerProc proc timerId:WPARAM

LOCAL systime:SYSTEMTIME

.data
timebuf db 12 dup (0)
timeformat db "hh':'mm':'ss tt",0
	
	.code
	
	mov eax, timerId
	
	cmp eax, IDC_TIMER
	jne notTimer

invoke GetLocalTime,addr systime
	
	invoke GetTimeFormat,NULL,0,addr systime,addr timeformat,addr timebuf,lengthof timebuf

invoke SendMessage,hStatus,SB_SETTEXT,5,addr timebuf
	
	jmp endTimerCompare
	
	notTimer:
	
	endTimerCompare:
	ret

timerProc endp


setStatusParts proc hWnd:HWND
	
LOCAL rcRect:RECT
invoke GetClientRect,hWnd,addr rcRect

mov eax, rcRect.right
sub eax, rcRect.left
	mov edx, 0
	
	mov ecx, 7
div  ecx

push ebx
mov ebx, eax

mov ecx, 0
startStatusLoop:
mov eax, ecx
mul ebx

mov statusParts[ecx*4], eax

inc ecx
cmp ecx, 6
jb startStatusLoop
endStatusLoop:
pop ebx

mov statusParts[ecx*4], -1


	invoke SendMessage,hStatus,SB_SETPARTS,7,addr statusParts

	
	ret

setStatusParts endp

end start
